allperiods=linspace(23,25,20);

try
  w=webread('http://geoweb.princeton.edu/people/simons/weather_data.csv');
  %% Read the data and make a simple plot
  time=w.x1445486040;
  temperature=w.x13_3;
catch
  w=load('weather_data.csv');
  temperature=w(:,5);
  time=w(:,1);
end

for index=1:length(allperiods)
  %% Finding diurnal cycles in the temperature record at Hargraves Hall - 1

  plot(time,temperature)

  %% Convert and plot in a human-intelligible format
  dates=time/24/60/60+datenum(1970,1,1,0,0,0);
  plot(dates,temperature)
  datetick('x',6)

  %% Convert and plot in hours since the first sample which is last
  hours=[dates-datenum(dates(end))]*24;
  plot(hours,temperature)
  set(gca,'xtick',0:24:hours(1))
  grid on
  xlabel('hours')
  ylabel('temperature')

  %% Make a 24-hour sinusoid to overlay on the data
  %P=24;
  P=allperiods(index);
  A=std(temperature);
  m=mean(temperature);
  ph=-9.05;
  diurnal=m+A*sin(2*pi*[hours-ph]/P);

  %% Now make a final-looking plot
  clf
  plot(hours,temperature)
  hold on
  p=plot(hours,diurnal,'k');
  xlabel('hours')
  ylabel('temperature')

  %% Compute the correlation coefficient between the synthetic and the data
  [r,pval]=corrcoef(temperature,diurnal);
  title(sprintf('The cc between T and a D and a P of %g with phase %g h is %g',...
                P,ph,r(2)))
  hold off

  pause
end
